


using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using SubSonic.DataProviders;
using SubSonic.Extensions;
using System.Linq.Expressions;
using SubSonic.Schema;
using System.Collections;
using SubSonic;
using SubSonic.Repository;
using System.ComponentModel;
using System.Data.Common;
using System.Web.Script.Serialization;

namespace ODAF.Data
{
    
    
    /// <summary>
    /// A class which represents the PointDataLayer table in the odaf Database.
    /// </summary>
    public partial class PointDataLayer: IActiveRecord
    {
    
        #region Built-in testing
        static TestRepository<PointDataLayer> _testRepo;
        

        
        static void SetTestRepo(){
            _testRepo = _testRepo ?? new TestRepository<PointDataLayer>(new ODAF.Data.odafDB());
        }
        public static void ResetTestRepo(){
            _testRepo = null;
            SetTestRepo();
        }
        public static void Setup(List<PointDataLayer> testlist){
            SetTestRepo();
            _testRepo._items = testlist;
        }
        public static void Setup(PointDataLayer item) {
            SetTestRepo();
            _testRepo._items.Add(item);
        }
        public static void Setup(int testItems) {
            SetTestRepo();
            for(int i=0;i<testItems;i++){
                PointDataLayer item=new PointDataLayer();
                _testRepo._items.Add(item);
            }
        }
        
        [ScriptIgnore]
        public bool TestMode = false;


        #endregion

        IRepository<PointDataLayer> _repo;
        ITable tbl;
        bool _isNew;
        public bool IsNew(){
            return _isNew;
        }
        
        public void SetIsLoaded(bool isLoaded){
            _isLoaded=isLoaded;
            if(isLoaded)
                OnLoaded();
        }
        
        public void SetIsNew(bool isNew){
            _isNew=isNew;
        }
        bool _isLoaded;
        public bool IsLoaded(){
            return _isLoaded;
        }
                
        List<IColumn> _dirtyColumns;
        public bool IsDirty(){
            return _dirtyColumns.Count>0;
        }
        
        public List<IColumn> GetDirtyColumns (){
            return _dirtyColumns;
        }

        ODAF.Data.odafDB _db;
        public PointDataLayer(string connectionString, string providerName) {

            _db=new ODAF.Data.odafDB(connectionString, providerName);
            Init();            
         }
        void Init(){
            TestMode=this._db.DataProvider.ConnectionString.Equals("test", StringComparison.InvariantCultureIgnoreCase);
            _dirtyColumns=new List<IColumn>();
            if(TestMode){
                PointDataLayer.SetTestRepo();
                _repo=_testRepo;
            }else{
                _repo = new SubSonicRepository<PointDataLayer>(_db);
            }
            tbl=_repo.GetTable();
            SetIsNew(true);
            OnCreated();       

        }
        
        public PointDataLayer(){
             _db=new ODAF.Data.odafDB();
            Init();            
        }
        
       
        partial void OnCreated();
            
        partial void OnLoaded();
        
        partial void OnSaved();
        
        partial void OnChanged();
        
        [ScriptIgnore]
        public IList<IColumn> Columns{
            get{
                return tbl.Columns;
            }
        }

        public PointDataLayer(Expression<Func<PointDataLayer, bool>> expression):this() {

            SetIsLoaded(_repo.Load(this,expression));
        }
        
       
        
        internal static IRepository<PointDataLayer> GetRepo(string connectionString, string providerName){
            ODAF.Data.odafDB db;
            if(String.IsNullOrEmpty(connectionString)){
                db=new ODAF.Data.odafDB();
            }else{
                db=new ODAF.Data.odafDB(connectionString, providerName);
            }
            IRepository<PointDataLayer> _repo;
            
            if(db.TestMode){
                PointDataLayer.SetTestRepo();
                _repo=_testRepo;
            }else{
                _repo = new SubSonicRepository<PointDataLayer>(db);
            }
            return _repo;        
        }       
        
        internal static IRepository<PointDataLayer> GetRepo(){
            return GetRepo("","");
        }
        
        public static PointDataLayer SingleOrDefault(Expression<Func<PointDataLayer, bool>> expression) {

            var repo = GetRepo();
            var results=repo.Find(expression);
            PointDataLayer single=null;
            if(results.Count() > 0){
                single=results.ToList()[0];
                single.OnLoaded();
                single.SetIsLoaded(true);
                single.SetIsNew(false);
            }

            return single;
        }      
        
        public static PointDataLayer SingleOrDefault(Expression<Func<PointDataLayer, bool>> expression,string connectionString, string providerName) {
            var repo = GetRepo(connectionString,providerName);
            var results=repo.Find(expression);
            PointDataLayer single=null;
            if(results.Count() > 0){
                single=results.ToList()[0];
            }

            return single;


        }
        
        
        public static bool Exists(Expression<Func<PointDataLayer, bool>> expression,string connectionString, string providerName) {
           
            return All(connectionString,providerName).Any(expression);
        }        
        public static bool Exists(Expression<Func<PointDataLayer, bool>> expression) {
           
            return All().Any(expression);
        }        

        public static IList<PointDataLayer> Find(Expression<Func<PointDataLayer, bool>> expression) {
            
            var repo = GetRepo();
            return repo.Find(expression).ToList();
        }
        
        public static IList<PointDataLayer> Find(Expression<Func<PointDataLayer, bool>> expression,string connectionString, string providerName) {

            var repo = GetRepo(connectionString,providerName);
            return repo.Find(expression).ToList();

        }
        public static IQueryable<PointDataLayer> All(string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetAll();
        }
        public static IQueryable<PointDataLayer> All() {
            return GetRepo().GetAll();
        }
        
        public static PagedList<PointDataLayer> GetPaged(string sortBy, int pageIndex, int pageSize,string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetPaged(sortBy, pageIndex, pageSize);
        }
      
        public static PagedList<PointDataLayer> GetPaged(string sortBy, int pageIndex, int pageSize) {
            return GetRepo().GetPaged(sortBy, pageIndex, pageSize);
        }

        public static PagedList<PointDataLayer> GetPaged(int pageIndex, int pageSize,string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetPaged(pageIndex, pageSize);
            
        }


        public static PagedList<PointDataLayer> GetPaged(int pageIndex, int pageSize) {
            return GetRepo().GetPaged(pageIndex, pageSize);
            
        }

        public string KeyName()
        {
            return "Id";
        }

        public object KeyValue()
        {
            return this.Id;
        }
        
        public void SetKeyValue(object value) {
            if (value != null && value!=DBNull.Value) {
                var settable = value.ChangeTypeTo<long>();
                this.GetType().GetProperty(this.KeyName()).SetValue(this, settable, null);
            }
        }
        
        public override string ToString(){
            return this.Guid.ToString();
        }

        public override bool Equals(object obj){
            if(obj.GetType()==typeof(PointDataLayer)){
                PointDataLayer compare=(PointDataLayer)obj;
                return compare.KeyValue()==this.KeyValue();
            }else{
                return base.Equals(obj);
            }
        }

        public string DescriptorValue()
        {
            return this.Guid.ToString();
        }

        public string DescriptorColumn() {
            return "Guid";
        }
        public static string GetKeyColumn()
        {
            return "Id";
        }        
        public static string GetDescriptorColumn()
        {
            return "Guid";
        }
        
        #region ' Foreign Keys '
        #endregion
        

        long _Id;
        public long Id
        {
            get { return _Id; }
            set
            {
                if(_Id!=value){
                    _Id=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Id");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _Guid;
        public string Guid
        {
            get { return _Guid; }
            set
            {
                if(_Guid!=value){
                    _Guid=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Guid");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _Name;
        public string Name
        {
            get { return _Name; }
            set
            {
                if(_Name!=value){
                    _Name=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Name");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        bool? _IsSystem;
        public bool? IsSystem
        {
            get { return _IsSystem; }
            set
            {
                if(_IsSystem!=value){
                    _IsSystem=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="IsSystem");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        DateTime? _CreatedOn;
        public DateTime? CreatedOn
        {
            get { return _CreatedOn; }
            set
            {
                if(_CreatedOn!=value){
                    _CreatedOn=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="CreatedOn");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }



        public DbCommand GetUpdateCommand() {
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToUpdateQuery(_db.Provider).GetCommand().ToDbCommand();
            
        }
        public DbCommand GetInsertCommand() {
 
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToInsertQuery(_db.Provider).GetCommand().ToDbCommand();
        }
        
        public DbCommand GetDeleteCommand() {
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToDeleteQuery(_db.Provider).GetCommand().ToDbCommand();
        }
       
        
        public void Update(){
            Update(_db.DataProvider);
        }
        
        public void Update(IDataProvider provider){
        
            
            if(this._dirtyColumns.Count>0)
                _repo.Update(this,provider);
            OnSaved();
       }
 
        public void Add(){
            Add(_db.DataProvider);
        }
        
        
       
        public void Add(IDataProvider provider){

            
            this.CreatedOn=DateTime.Now;
            
            var key=KeyValue();
            if(key==null){
                var newKey=_repo.Add(this,provider);
                this.SetKeyValue(newKey);
            }else{
                _repo.Add(this,provider);
            }
            SetIsNew(false);
            OnSaved();
        }
        
                
        
        public void Save() {
            Save(_db.DataProvider);
        }      
        public void Save(IDataProvider provider) {
            
           
            if (_isNew) {
                Add(provider);
                
            } else {
                Update(provider);
            }
            
        }

        

        public void Delete(IDataProvider provider) {
                   
                 
            _repo.Delete(KeyValue());
            
                    }


        public void Delete() {
            Delete(_db.DataProvider);
        }


        public static void Delete(Expression<Func<PointDataLayer, bool>> expression) {
            var repo = GetRepo();
            
       
            
            repo.DeleteMany(expression);
            
        }

        

        public void Load(IDataReader rdr) {
            Load(rdr, true);
        }
        public void Load(IDataReader rdr, bool closeReader) {
            if (rdr.Read()) {

                try {
                    rdr.Load(this);
                    SetIsNew(false);
                    SetIsLoaded(true);
                } catch {
                    SetIsLoaded(false);
                    throw;
                }
            }else{
                SetIsLoaded(false);
            }

            if (closeReader)
                rdr.Dispose();
        }
        

    } 
    
    
    /// <summary>
    /// A class which represents the PointDataSummary table in the odaf Database.
    /// </summary>
    public partial class PointDataSummary: IActiveRecord
    {
    
        #region Built-in testing
        static TestRepository<PointDataSummary> _testRepo;
        

        
        static void SetTestRepo(){
            _testRepo = _testRepo ?? new TestRepository<PointDataSummary>(new ODAF.Data.odafDB());
        }
        public static void ResetTestRepo(){
            _testRepo = null;
            SetTestRepo();
        }
        public static void Setup(List<PointDataSummary> testlist){
            SetTestRepo();
            _testRepo._items = testlist;
        }
        public static void Setup(PointDataSummary item) {
            SetTestRepo();
            _testRepo._items.Add(item);
        }
        public static void Setup(int testItems) {
            SetTestRepo();
            for(int i=0;i<testItems;i++){
                PointDataSummary item=new PointDataSummary();
                _testRepo._items.Add(item);
            }
        }
        
        [ScriptIgnore]
        public bool TestMode = false;


        #endregion

        IRepository<PointDataSummary> _repo;
        ITable tbl;
        bool _isNew;
        public bool IsNew(){
            return _isNew;
        }
        
        public void SetIsLoaded(bool isLoaded){
            _isLoaded=isLoaded;
            if(isLoaded)
                OnLoaded();
        }
        
        public void SetIsNew(bool isNew){
            _isNew=isNew;
        }
        bool _isLoaded;
        public bool IsLoaded(){
            return _isLoaded;
        }
                
        List<IColumn> _dirtyColumns;
        public bool IsDirty(){
            return _dirtyColumns.Count>0;
        }
        
        public List<IColumn> GetDirtyColumns (){
            return _dirtyColumns;
        }

        ODAF.Data.odafDB _db;
        public PointDataSummary(string connectionString, string providerName) {

            _db=new ODAF.Data.odafDB(connectionString, providerName);
            Init();            
         }
        void Init(){
            TestMode=this._db.DataProvider.ConnectionString.Equals("test", StringComparison.InvariantCultureIgnoreCase);
            _dirtyColumns=new List<IColumn>();
            if(TestMode){
                PointDataSummary.SetTestRepo();
                _repo=_testRepo;
            }else{
                _repo = new SubSonicRepository<PointDataSummary>(_db);
            }
            tbl=_repo.GetTable();
            SetIsNew(true);
            OnCreated();       

        }
        
        public PointDataSummary(){
             _db=new ODAF.Data.odafDB();
            Init();            
        }
        
       
        partial void OnCreated();
            
        partial void OnLoaded();
        
        partial void OnSaved();
        
        partial void OnChanged();
        
        [ScriptIgnore]
        public IList<IColumn> Columns{
            get{
                return tbl.Columns;
            }
        }

        public PointDataSummary(Expression<Func<PointDataSummary, bool>> expression):this() {

            SetIsLoaded(_repo.Load(this,expression));
        }
        
       
        
        internal static IRepository<PointDataSummary> GetRepo(string connectionString, string providerName){
            ODAF.Data.odafDB db;
            if(String.IsNullOrEmpty(connectionString)){
                db=new ODAF.Data.odafDB();
            }else{
                db=new ODAF.Data.odafDB(connectionString, providerName);
            }
            IRepository<PointDataSummary> _repo;
            
            if(db.TestMode){
                PointDataSummary.SetTestRepo();
                _repo=_testRepo;
            }else{
                _repo = new SubSonicRepository<PointDataSummary>(db);
            }
            return _repo;        
        }       
        
        internal static IRepository<PointDataSummary> GetRepo(){
            return GetRepo("","");
        }
        
        public static PointDataSummary SingleOrDefault(Expression<Func<PointDataSummary, bool>> expression) {

            var repo = GetRepo();
            var results=repo.Find(expression);
            PointDataSummary single=null;
            if(results.Count() > 0){
                single=results.ToList()[0];
                single.OnLoaded();
                single.SetIsLoaded(true);
                single.SetIsNew(false);
            }

            return single;
        }      
        
        public static PointDataSummary SingleOrDefault(Expression<Func<PointDataSummary, bool>> expression,string connectionString, string providerName) {
            var repo = GetRepo(connectionString,providerName);
            var results=repo.Find(expression);
            PointDataSummary single=null;
            if(results.Count() > 0){
                single=results.ToList()[0];
            }

            return single;


        }
        
        
        public static bool Exists(Expression<Func<PointDataSummary, bool>> expression,string connectionString, string providerName) {
           
            return All(connectionString,providerName).Any(expression);
        }        
        public static bool Exists(Expression<Func<PointDataSummary, bool>> expression) {
           
            return All().Any(expression);
        }        

        public static IList<PointDataSummary> Find(Expression<Func<PointDataSummary, bool>> expression) {
            
            var repo = GetRepo();
            return repo.Find(expression).ToList();
        }
        
        public static IList<PointDataSummary> Find(Expression<Func<PointDataSummary, bool>> expression,string connectionString, string providerName) {

            var repo = GetRepo(connectionString,providerName);
            return repo.Find(expression).ToList();

        }
        public static IQueryable<PointDataSummary> All(string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetAll();
        }
        public static IQueryable<PointDataSummary> All() {
            return GetRepo().GetAll();
        }
        
        public static PagedList<PointDataSummary> GetPaged(string sortBy, int pageIndex, int pageSize,string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetPaged(sortBy, pageIndex, pageSize);
        }
      
        public static PagedList<PointDataSummary> GetPaged(string sortBy, int pageIndex, int pageSize) {
            return GetRepo().GetPaged(sortBy, pageIndex, pageSize);
        }

        public static PagedList<PointDataSummary> GetPaged(int pageIndex, int pageSize,string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetPaged(pageIndex, pageSize);
            
        }


        public static PagedList<PointDataSummary> GetPaged(int pageIndex, int pageSize) {
            return GetRepo().GetPaged(pageIndex, pageSize);
            
        }

        public string KeyName()
        {
            return "Id";
        }

        public object KeyValue()
        {
            return this.Id;
        }
        
        public void SetKeyValue(object value) {
            if (value != null && value!=DBNull.Value) {
                var settable = value.ChangeTypeTo<long>();
                this.GetType().GetProperty(this.KeyName()).SetValue(this, settable, null);
            }
        }
        
        public override string ToString(){
            return this.Description.ToString();
        }

        public override bool Equals(object obj){
            if(obj.GetType()==typeof(PointDataSummary)){
                PointDataSummary compare=(PointDataSummary)obj;
                return compare.KeyValue()==this.KeyValue();
            }else{
                return base.Equals(obj);
            }
        }

        public string DescriptorValue()
        {
            return this.Description.ToString();
        }

        public string DescriptorColumn() {
            return "Description";
        }
        public static string GetKeyColumn()
        {
            return "Id";
        }        
        public static string GetDescriptorColumn()
        {
            return "Description";
        }
        
        #region ' Foreign Keys '
		[ScriptIgnore]
        public IQueryable<PointDataComment> PointDataComments
        {
            get
            {
                
                  var repo=ODAF.Data.PointDataComment.GetRepo();
                  return from items in repo.GetAll()
                       where items.SummaryId == _Id
                       select items;
            }
        }

		[ScriptIgnore]
        public IQueryable<OAuthAccount> OAuthAccounts
        {
            get
            {
                
                  var repo=ODAF.Data.OAuthAccount.GetRepo();
                  return from items in repo.GetAll()
                       where items.Id == _CreatedById
                       select items;
            }
        }

        #endregion
        

        long _Id;
        public long Id
        {
            get { return _Id; }
            set
            {
                if(_Id!=value){
                    _Id=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Id");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _Description;
        public string Description
        {
            get { return _Description; }
            set
            {
                if(_Description!=value){
                    _Description=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Description");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        decimal _Latitude;
        public decimal Latitude
        {
            get { return _Latitude; }
            set
            {
                if(_Latitude!=value){
                    _Latitude=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Latitude");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        decimal _Longitude;
        public decimal Longitude
        {
            get { return _Longitude; }
            set
            {
                if(_Longitude!=value){
                    _Longitude=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Longitude");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _LayerId;
        public string LayerId
        {
            get { return _LayerId; }
            set
            {
                if(_LayerId!=value){
                    _LayerId=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="LayerId");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _Tag;
        public string Tag
        {
            get { return _Tag; }
            set
            {
                if(_Tag!=value){
                    _Tag=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Tag");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        int _RatingCount;
        public int RatingCount
        {
            get { return _RatingCount; }
            set
            {
                if(_RatingCount!=value){
                    _RatingCount=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="RatingCount");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        long _RatingTotal;
        public long RatingTotal
        {
            get { return _RatingTotal; }
            set
            {
                if(_RatingTotal!=value){
                    _RatingTotal=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="RatingTotal");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        int _CommentCount;
        public int CommentCount
        {
            get { return _CommentCount; }
            set
            {
                if(_CommentCount!=value){
                    _CommentCount=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="CommentCount");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        DateTime? _CreatedOn;
        public DateTime? CreatedOn
        {
            get { return _CreatedOn; }
            set
            {
                if(_CreatedOn!=value){
                    _CreatedOn=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="CreatedOn");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        DateTime? _ModifiedOn;
        public DateTime? ModifiedOn
        {
            get { return _ModifiedOn; }
            set
            {
                if(_ModifiedOn!=value){
                    _ModifiedOn=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="ModifiedOn");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _Guid;
        public string Guid
        {
            get { return _Guid; }
            set
            {
                if(_Guid!=value){
                    _Guid=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Guid");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _Name;
        public string Name
        {
            get { return _Name; }
            set
            {
                if(_Name!=value){
                    _Name=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Name");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        long _CreatedById;
        public long CreatedById
        {
            get { return _CreatedById; }
            set
            {
                if(_CreatedById!=value){
                    _CreatedById=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="CreatedById");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }



        public DbCommand GetUpdateCommand() {
            if (!_dirtyColumns.Any(x => x.Name.ToLower() == "modifiedon")) {
               this.ModifiedOn=DateTime.Now;
            }            
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToUpdateQuery(_db.Provider).GetCommand().ToDbCommand();
            
        }
        public DbCommand GetInsertCommand() {
 
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToInsertQuery(_db.Provider).GetCommand().ToDbCommand();
        }
        
        public DbCommand GetDeleteCommand() {
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToDeleteQuery(_db.Provider).GetCommand().ToDbCommand();
        }
       
        
        public void Update(){
            Update(_db.DataProvider);
        }
        
        public void Update(IDataProvider provider){
        
            this.ModifiedOn=DateTime.Now;
            
            if(this._dirtyColumns.Count>0)
                _repo.Update(this,provider);
            OnSaved();
       }
 
        public void Add(){
            Add(_db.DataProvider);
        }
        
        
       
        public void Add(IDataProvider provider){

            
            this.CreatedOn=DateTime.Now;
            this.ModifiedOn=DateTime.Now;
            
            var key=KeyValue();
            if(key==null){
                var newKey=_repo.Add(this,provider);
                this.SetKeyValue(newKey);
            }else{
                _repo.Add(this,provider);
            }
            SetIsNew(false);
            OnSaved();
        }
        
                
        
        public void Save() {
            Save(_db.DataProvider);
        }      
        public void Save(IDataProvider provider) {
            
           
            if (_isNew) {
                Add(provider);
                
            } else {
                Update(provider);
            }
            
        }

        

        public void Delete(IDataProvider provider) {
                   
                 
            _repo.Delete(KeyValue());
            
                    }


        public void Delete() {
            Delete(_db.DataProvider);
        }


        public static void Delete(Expression<Func<PointDataSummary, bool>> expression) {
            var repo = GetRepo();
            
       
            
            repo.DeleteMany(expression);
            
        }

        

        public void Load(IDataReader rdr) {
            Load(rdr, true);
        }
        public void Load(IDataReader rdr, bool closeReader) {
            if (rdr.Read()) {

                try {
                    rdr.Load(this);
                    SetIsNew(false);
                    SetIsLoaded(true);
                } catch {
                    SetIsLoaded(false);
                    throw;
                }
            }else{
                SetIsLoaded(false);
            }

            if (closeReader)
                rdr.Dispose();
        }
        

    } 
    
    
    /// <summary>
    /// A class which represents the PointDataComment table in the odaf Database.
    /// </summary>
    public partial class PointDataComment: IActiveRecord
    {
    
        #region Built-in testing
        static TestRepository<PointDataComment> _testRepo;
        

        
        static void SetTestRepo(){
            _testRepo = _testRepo ?? new TestRepository<PointDataComment>(new ODAF.Data.odafDB());
        }
        public static void ResetTestRepo(){
            _testRepo = null;
            SetTestRepo();
        }
        public static void Setup(List<PointDataComment> testlist){
            SetTestRepo();
            _testRepo._items = testlist;
        }
        public static void Setup(PointDataComment item) {
            SetTestRepo();
            _testRepo._items.Add(item);
        }
        public static void Setup(int testItems) {
            SetTestRepo();
            for(int i=0;i<testItems;i++){
                PointDataComment item=new PointDataComment();
                _testRepo._items.Add(item);
            }
        }
        
        [ScriptIgnore]
        public bool TestMode = false;


        #endregion

        IRepository<PointDataComment> _repo;
        ITable tbl;
        bool _isNew;
        public bool IsNew(){
            return _isNew;
        }
        
        public void SetIsLoaded(bool isLoaded){
            _isLoaded=isLoaded;
            if(isLoaded)
                OnLoaded();
        }
        
        public void SetIsNew(bool isNew){
            _isNew=isNew;
        }
        bool _isLoaded;
        public bool IsLoaded(){
            return _isLoaded;
        }
                
        List<IColumn> _dirtyColumns;
        public bool IsDirty(){
            return _dirtyColumns.Count>0;
        }
        
        public List<IColumn> GetDirtyColumns (){
            return _dirtyColumns;
        }

        ODAF.Data.odafDB _db;
        public PointDataComment(string connectionString, string providerName) {

            _db=new ODAF.Data.odafDB(connectionString, providerName);
            Init();            
         }
        void Init(){
            TestMode=this._db.DataProvider.ConnectionString.Equals("test", StringComparison.InvariantCultureIgnoreCase);
            _dirtyColumns=new List<IColumn>();
            if(TestMode){
                PointDataComment.SetTestRepo();
                _repo=_testRepo;
            }else{
                _repo = new SubSonicRepository<PointDataComment>(_db);
            }
            tbl=_repo.GetTable();
            SetIsNew(true);
            OnCreated();       

        }
        
        public PointDataComment(){
             _db=new ODAF.Data.odafDB();
            Init();            
        }
        
       
        partial void OnCreated();
            
        partial void OnLoaded();
        
        partial void OnSaved();
        
        partial void OnChanged();
        
        [ScriptIgnore]
        public IList<IColumn> Columns{
            get{
                return tbl.Columns;
            }
        }

        public PointDataComment(Expression<Func<PointDataComment, bool>> expression):this() {

            SetIsLoaded(_repo.Load(this,expression));
        }
        
       
        
        internal static IRepository<PointDataComment> GetRepo(string connectionString, string providerName){
            ODAF.Data.odafDB db;
            if(String.IsNullOrEmpty(connectionString)){
                db=new ODAF.Data.odafDB();
            }else{
                db=new ODAF.Data.odafDB(connectionString, providerName);
            }
            IRepository<PointDataComment> _repo;
            
            if(db.TestMode){
                PointDataComment.SetTestRepo();
                _repo=_testRepo;
            }else{
                _repo = new SubSonicRepository<PointDataComment>(db);
            }
            return _repo;        
        }       
        
        internal static IRepository<PointDataComment> GetRepo(){
            return GetRepo("","");
        }
        
        public static PointDataComment SingleOrDefault(Expression<Func<PointDataComment, bool>> expression) {

            var repo = GetRepo();
            var results=repo.Find(expression);
            PointDataComment single=null;
            if(results.Count() > 0){
                single=results.ToList()[0];
                single.OnLoaded();
                single.SetIsLoaded(true);
                single.SetIsNew(false);
            }

            return single;
        }      
        
        public static PointDataComment SingleOrDefault(Expression<Func<PointDataComment, bool>> expression,string connectionString, string providerName) {
            var repo = GetRepo(connectionString,providerName);
            var results=repo.Find(expression);
            PointDataComment single=null;
            if(results.Count() > 0){
                single=results.ToList()[0];
            }

            return single;


        }
        
        
        public static bool Exists(Expression<Func<PointDataComment, bool>> expression,string connectionString, string providerName) {
           
            return All(connectionString,providerName).Any(expression);
        }        
        public static bool Exists(Expression<Func<PointDataComment, bool>> expression) {
           
            return All().Any(expression);
        }        

        public static IList<PointDataComment> Find(Expression<Func<PointDataComment, bool>> expression) {
            
            var repo = GetRepo();
            return repo.Find(expression).ToList();
        }
        
        public static IList<PointDataComment> Find(Expression<Func<PointDataComment, bool>> expression,string connectionString, string providerName) {

            var repo = GetRepo(connectionString,providerName);
            return repo.Find(expression).ToList();

        }
        public static IQueryable<PointDataComment> All(string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetAll();
        }
        public static IQueryable<PointDataComment> All() {
            return GetRepo().GetAll();
        }
        
        public static PagedList<PointDataComment> GetPaged(string sortBy, int pageIndex, int pageSize,string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetPaged(sortBy, pageIndex, pageSize);
        }
      
        public static PagedList<PointDataComment> GetPaged(string sortBy, int pageIndex, int pageSize) {
            return GetRepo().GetPaged(sortBy, pageIndex, pageSize);
        }

        public static PagedList<PointDataComment> GetPaged(int pageIndex, int pageSize,string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetPaged(pageIndex, pageSize);
            
        }


        public static PagedList<PointDataComment> GetPaged(int pageIndex, int pageSize) {
            return GetRepo().GetPaged(pageIndex, pageSize);
            
        }

        public string KeyName()
        {
            return "Id";
        }

        public object KeyValue()
        {
            return this.Id;
        }
        
        public void SetKeyValue(object value) {
            if (value != null && value!=DBNull.Value) {
                var settable = value.ChangeTypeTo<long>();
                this.GetType().GetProperty(this.KeyName()).SetValue(this, settable, null);
            }
        }
        
        public override string ToString(){
            return this.Text.ToString();
        }

        public override bool Equals(object obj){
            if(obj.GetType()==typeof(PointDataComment)){
                PointDataComment compare=(PointDataComment)obj;
                return compare.KeyValue()==this.KeyValue();
            }else{
                return base.Equals(obj);
            }
        }

        public string DescriptorValue()
        {
            return this.Text.ToString();
        }

        public string DescriptorColumn() {
            return "Text";
        }
        public static string GetKeyColumn()
        {
            return "Id";
        }        
        public static string GetDescriptorColumn()
        {
            return "Text";
        }
        
        #region ' Foreign Keys '
		[ScriptIgnore]
        public IQueryable<OAuthAccount> OAuthAccounts
        {
            get
            {
                
                  var repo=ODAF.Data.OAuthAccount.GetRepo();
                  return from items in repo.GetAll()
                       where items.Id == _CreatedById
                       select items;
            }
        }

		[ScriptIgnore]
        public IQueryable<PointDataSummary> PointDataSummaries
        {
            get
            {
                
                  var repo=ODAF.Data.PointDataSummary.GetRepo();
                  return from items in repo.GetAll()
                       where items.Id == _SummaryId
                       select items;
            }
        }

        #endregion
        

        long _Id;
        public long Id
        {
            get { return _Id; }
            set
            {
                if(_Id!=value){
                    _Id=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Id");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _Text;
        public string Text
        {
            get { return _Text; }
            set
            {
                if(_Text!=value){
                    _Text=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Text");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        DateTime? _CreatedOn;
        public DateTime? CreatedOn
        {
            get { return _CreatedOn; }
            set
            {
                if(_CreatedOn!=value){
                    _CreatedOn=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="CreatedOn");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        long _CreatedById;
        public long CreatedById
        {
            get { return _CreatedById; }
            set
            {
                if(_CreatedById!=value){
                    _CreatedById=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="CreatedById");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        long _SummaryId;
        public long SummaryId
        {
            get { return _SummaryId; }
            set
            {
                if(_SummaryId!=value){
                    _SummaryId=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="SummaryId");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }



        public DbCommand GetUpdateCommand() {
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToUpdateQuery(_db.Provider).GetCommand().ToDbCommand();
            
        }
        public DbCommand GetInsertCommand() {
 
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToInsertQuery(_db.Provider).GetCommand().ToDbCommand();
        }
        
        public DbCommand GetDeleteCommand() {
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToDeleteQuery(_db.Provider).GetCommand().ToDbCommand();
        }
       
        
        public void Update(){
            Update(_db.DataProvider);
        }
        
        public void Update(IDataProvider provider){
        
            
            if(this._dirtyColumns.Count>0)
                _repo.Update(this,provider);
            OnSaved();
       }
 
        public void Add(){
            Add(_db.DataProvider);
        }
        
        
       
        public void Add(IDataProvider provider){

            
            this.CreatedOn=DateTime.Now;
            
            var key=KeyValue();
            if(key==null){
                var newKey=_repo.Add(this,provider);
                this.SetKeyValue(newKey);
            }else{
                _repo.Add(this,provider);
            }
            SetIsNew(false);
            OnSaved();
        }
        
                
        
        public void Save() {
            Save(_db.DataProvider);
        }      
        public void Save(IDataProvider provider) {
            
           
            if (_isNew) {
                Add(provider);
                
            } else {
                Update(provider);
            }
            
        }

        

        public void Delete(IDataProvider provider) {
                   
                 
            _repo.Delete(KeyValue());
            
                    }


        public void Delete() {
            Delete(_db.DataProvider);
        }


        public static void Delete(Expression<Func<PointDataComment, bool>> expression) {
            var repo = GetRepo();
            
       
            
            repo.DeleteMany(expression);
            
        }

        

        public void Load(IDataReader rdr) {
            Load(rdr, true);
        }
        public void Load(IDataReader rdr, bool closeReader) {
            if (rdr.Read()) {

                try {
                    rdr.Load(this);
                    SetIsNew(false);
                    SetIsLoaded(true);
                } catch {
                    SetIsLoaded(false);
                    throw;
                }
            }else{
                SetIsLoaded(false);
            }

            if (closeReader)
                rdr.Dispose();
        }
        

    } 
    
    
    /// <summary>
    /// A class which represents the UserRole table in the odaf Database.
    /// </summary>
    public partial class UserRole: IActiveRecord
    {
    
        #region Built-in testing
        static TestRepository<UserRole> _testRepo;
        

        
        static void SetTestRepo(){
            _testRepo = _testRepo ?? new TestRepository<UserRole>(new ODAF.Data.odafDB());
        }
        public static void ResetTestRepo(){
            _testRepo = null;
            SetTestRepo();
        }
        public static void Setup(List<UserRole> testlist){
            SetTestRepo();
            _testRepo._items = testlist;
        }
        public static void Setup(UserRole item) {
            SetTestRepo();
            _testRepo._items.Add(item);
        }
        public static void Setup(int testItems) {
            SetTestRepo();
            for(int i=0;i<testItems;i++){
                UserRole item=new UserRole();
                _testRepo._items.Add(item);
            }
        }
        
        [ScriptIgnore]
        public bool TestMode = false;


        #endregion

        IRepository<UserRole> _repo;
        ITable tbl;
        bool _isNew;
        public bool IsNew(){
            return _isNew;
        }
        
        public void SetIsLoaded(bool isLoaded){
            _isLoaded=isLoaded;
            if(isLoaded)
                OnLoaded();
        }
        
        public void SetIsNew(bool isNew){
            _isNew=isNew;
        }
        bool _isLoaded;
        public bool IsLoaded(){
            return _isLoaded;
        }
                
        List<IColumn> _dirtyColumns;
        public bool IsDirty(){
            return _dirtyColumns.Count>0;
        }
        
        public List<IColumn> GetDirtyColumns (){
            return _dirtyColumns;
        }

        ODAF.Data.odafDB _db;
        public UserRole(string connectionString, string providerName) {

            _db=new ODAF.Data.odafDB(connectionString, providerName);
            Init();            
         }
        void Init(){
            TestMode=this._db.DataProvider.ConnectionString.Equals("test", StringComparison.InvariantCultureIgnoreCase);
            _dirtyColumns=new List<IColumn>();
            if(TestMode){
                UserRole.SetTestRepo();
                _repo=_testRepo;
            }else{
                _repo = new SubSonicRepository<UserRole>(_db);
            }
            tbl=_repo.GetTable();
            SetIsNew(true);
            OnCreated();       

        }
        
        public UserRole(){
             _db=new ODAF.Data.odafDB();
            Init();            
        }
        
       
        partial void OnCreated();
            
        partial void OnLoaded();
        
        partial void OnSaved();
        
        partial void OnChanged();
        
        [ScriptIgnore]
        public IList<IColumn> Columns{
            get{
                return tbl.Columns;
            }
        }

        public UserRole(Expression<Func<UserRole, bool>> expression):this() {

            SetIsLoaded(_repo.Load(this,expression));
        }
        
       
        
        internal static IRepository<UserRole> GetRepo(string connectionString, string providerName){
            ODAF.Data.odafDB db;
            if(String.IsNullOrEmpty(connectionString)){
                db=new ODAF.Data.odafDB();
            }else{
                db=new ODAF.Data.odafDB(connectionString, providerName);
            }
            IRepository<UserRole> _repo;
            
            if(db.TestMode){
                UserRole.SetTestRepo();
                _repo=_testRepo;
            }else{
                _repo = new SubSonicRepository<UserRole>(db);
            }
            return _repo;        
        }       
        
        internal static IRepository<UserRole> GetRepo(){
            return GetRepo("","");
        }
        
        public static UserRole SingleOrDefault(Expression<Func<UserRole, bool>> expression) {

            var repo = GetRepo();
            var results=repo.Find(expression);
            UserRole single=null;
            if(results.Count() > 0){
                single=results.ToList()[0];
                single.OnLoaded();
                single.SetIsLoaded(true);
                single.SetIsNew(false);
            }

            return single;
        }      
        
        public static UserRole SingleOrDefault(Expression<Func<UserRole, bool>> expression,string connectionString, string providerName) {
            var repo = GetRepo(connectionString,providerName);
            var results=repo.Find(expression);
            UserRole single=null;
            if(results.Count() > 0){
                single=results.ToList()[0];
            }

            return single;


        }
        
        
        public static bool Exists(Expression<Func<UserRole, bool>> expression,string connectionString, string providerName) {
           
            return All(connectionString,providerName).Any(expression);
        }        
        public static bool Exists(Expression<Func<UserRole, bool>> expression) {
           
            return All().Any(expression);
        }        

        public static IList<UserRole> Find(Expression<Func<UserRole, bool>> expression) {
            
            var repo = GetRepo();
            return repo.Find(expression).ToList();
        }
        
        public static IList<UserRole> Find(Expression<Func<UserRole, bool>> expression,string connectionString, string providerName) {

            var repo = GetRepo(connectionString,providerName);
            return repo.Find(expression).ToList();

        }
        public static IQueryable<UserRole> All(string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetAll();
        }
        public static IQueryable<UserRole> All() {
            return GetRepo().GetAll();
        }
        
        public static PagedList<UserRole> GetPaged(string sortBy, int pageIndex, int pageSize,string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetPaged(sortBy, pageIndex, pageSize);
        }
      
        public static PagedList<UserRole> GetPaged(string sortBy, int pageIndex, int pageSize) {
            return GetRepo().GetPaged(sortBy, pageIndex, pageSize);
        }

        public static PagedList<UserRole> GetPaged(int pageIndex, int pageSize,string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetPaged(pageIndex, pageSize);
            
        }


        public static PagedList<UserRole> GetPaged(int pageIndex, int pageSize) {
            return GetRepo().GetPaged(pageIndex, pageSize);
            
        }

        public string KeyName()
        {
            return "Code";
        }

        public object KeyValue()
        {
            return this.Code;
        }
        
        public void SetKeyValue(object value) {
            if (value != null && value!=DBNull.Value) {
                var settable = value.ChangeTypeTo<short>();
                this.GetType().GetProperty(this.KeyName()).SetValue(this, settable, null);
            }
        }
        
        public override string ToString(){
            return this.Name.ToString();
        }

        public override bool Equals(object obj){
            if(obj.GetType()==typeof(UserRole)){
                UserRole compare=(UserRole)obj;
                return compare.KeyValue()==this.KeyValue();
            }else{
                return base.Equals(obj);
            }
        }

        public string DescriptorValue()
        {
            return this.Name.ToString();
        }

        public string DescriptorColumn() {
            return "Name";
        }
        public static string GetKeyColumn()
        {
            return "Code";
        }        
        public static string GetDescriptorColumn()
        {
            return "Name";
        }
        
        #region ' Foreign Keys '
		[ScriptIgnore]
        public IQueryable<OAuthAccount> OAuthAccounts
        {
            get
            {
                
                  var repo=ODAF.Data.OAuthAccount.GetRepo();
                  return from items in repo.GetAll()
                       where items.UserRole == _Code
                       select items;
            }
        }

        #endregion
        

        short _Code;
        public short Code
        {
            get { return _Code; }
            set
            {
                if(_Code!=value){
                    _Code=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Code");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _Name;
        public string Name
        {
            get { return _Name; }
            set
            {
                if(_Name!=value){
                    _Name=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Name");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }



        public DbCommand GetUpdateCommand() {
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToUpdateQuery(_db.Provider).GetCommand().ToDbCommand();
            
        }
        public DbCommand GetInsertCommand() {
 
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToInsertQuery(_db.Provider).GetCommand().ToDbCommand();
        }
        
        public DbCommand GetDeleteCommand() {
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToDeleteQuery(_db.Provider).GetCommand().ToDbCommand();
        }
       
        
        public void Update(){
            Update(_db.DataProvider);
        }
        
        public void Update(IDataProvider provider){
        
            
            if(this._dirtyColumns.Count>0)
                _repo.Update(this,provider);
            OnSaved();
       }
 
        public void Add(){
            Add(_db.DataProvider);
        }
        
        
       
        public void Add(IDataProvider provider){

            
            var key=KeyValue();
            if(key==null){
                var newKey=_repo.Add(this,provider);
                this.SetKeyValue(newKey);
            }else{
                _repo.Add(this,provider);
            }
            SetIsNew(false);
            OnSaved();
        }
        
                
        
        public void Save() {
            Save(_db.DataProvider);
        }      
        public void Save(IDataProvider provider) {
            
           
            if (_isNew) {
                Add(provider);
                
            } else {
                Update(provider);
            }
            
        }

        

        public void Delete(IDataProvider provider) {
                   
                 
            _repo.Delete(KeyValue());
            
                    }


        public void Delete() {
            Delete(_db.DataProvider);
        }


        public static void Delete(Expression<Func<UserRole, bool>> expression) {
            var repo = GetRepo();
            
       
            
            repo.DeleteMany(expression);
            
        }

        

        public void Load(IDataReader rdr) {
            Load(rdr, true);
        }
        public void Load(IDataReader rdr, bool closeReader) {
            if (rdr.Read()) {

                try {
                    rdr.Load(this);
                    SetIsNew(false);
                    SetIsLoaded(true);
                } catch {
                    SetIsLoaded(false);
                    throw;
                }
            }else{
                SetIsLoaded(false);
            }

            if (closeReader)
                rdr.Dispose();
        }
        

    } 
    
    
    /// <summary>
    /// A class which represents the UserAccess table in the odaf Database.
    /// </summary>
    public partial class UserAccess: IActiveRecord
    {
    
        #region Built-in testing
        static TestRepository<UserAccess> _testRepo;
        

        
        static void SetTestRepo(){
            _testRepo = _testRepo ?? new TestRepository<UserAccess>(new ODAF.Data.odafDB());
        }
        public static void ResetTestRepo(){
            _testRepo = null;
            SetTestRepo();
        }
        public static void Setup(List<UserAccess> testlist){
            SetTestRepo();
            _testRepo._items = testlist;
        }
        public static void Setup(UserAccess item) {
            SetTestRepo();
            _testRepo._items.Add(item);
        }
        public static void Setup(int testItems) {
            SetTestRepo();
            for(int i=0;i<testItems;i++){
                UserAccess item=new UserAccess();
                _testRepo._items.Add(item);
            }
        }
        
        [ScriptIgnore]
        public bool TestMode = false;


        #endregion

        IRepository<UserAccess> _repo;
        ITable tbl;
        bool _isNew;
        public bool IsNew(){
            return _isNew;
        }
        
        public void SetIsLoaded(bool isLoaded){
            _isLoaded=isLoaded;
            if(isLoaded)
                OnLoaded();
        }
        
        public void SetIsNew(bool isNew){
            _isNew=isNew;
        }
        bool _isLoaded;
        public bool IsLoaded(){
            return _isLoaded;
        }
                
        List<IColumn> _dirtyColumns;
        public bool IsDirty(){
            return _dirtyColumns.Count>0;
        }
        
        public List<IColumn> GetDirtyColumns (){
            return _dirtyColumns;
        }

        ODAF.Data.odafDB _db;
        public UserAccess(string connectionString, string providerName) {

            _db=new ODAF.Data.odafDB(connectionString, providerName);
            Init();            
         }
        void Init(){
            TestMode=this._db.DataProvider.ConnectionString.Equals("test", StringComparison.InvariantCultureIgnoreCase);
            _dirtyColumns=new List<IColumn>();
            if(TestMode){
                UserAccess.SetTestRepo();
                _repo=_testRepo;
            }else{
                _repo = new SubSonicRepository<UserAccess>(_db);
            }
            tbl=_repo.GetTable();
            SetIsNew(true);
            OnCreated();       

        }
        
        public UserAccess(){
             _db=new ODAF.Data.odafDB();
            Init();            
        }
        
       
        partial void OnCreated();
            
        partial void OnLoaded();
        
        partial void OnSaved();
        
        partial void OnChanged();
        
        [ScriptIgnore]
        public IList<IColumn> Columns{
            get{
                return tbl.Columns;
            }
        }

        public UserAccess(Expression<Func<UserAccess, bool>> expression):this() {

            SetIsLoaded(_repo.Load(this,expression));
        }
        
       
        
        internal static IRepository<UserAccess> GetRepo(string connectionString, string providerName){
            ODAF.Data.odafDB db;
            if(String.IsNullOrEmpty(connectionString)){
                db=new ODAF.Data.odafDB();
            }else{
                db=new ODAF.Data.odafDB(connectionString, providerName);
            }
            IRepository<UserAccess> _repo;
            
            if(db.TestMode){
                UserAccess.SetTestRepo();
                _repo=_testRepo;
            }else{
                _repo = new SubSonicRepository<UserAccess>(db);
            }
            return _repo;        
        }       
        
        internal static IRepository<UserAccess> GetRepo(){
            return GetRepo("","");
        }
        
        public static UserAccess SingleOrDefault(Expression<Func<UserAccess, bool>> expression) {

            var repo = GetRepo();
            var results=repo.Find(expression);
            UserAccess single=null;
            if(results.Count() > 0){
                single=results.ToList()[0];
                single.OnLoaded();
                single.SetIsLoaded(true);
                single.SetIsNew(false);
            }

            return single;
        }      
        
        public static UserAccess SingleOrDefault(Expression<Func<UserAccess, bool>> expression,string connectionString, string providerName) {
            var repo = GetRepo(connectionString,providerName);
            var results=repo.Find(expression);
            UserAccess single=null;
            if(results.Count() > 0){
                single=results.ToList()[0];
            }

            return single;


        }
        
        
        public static bool Exists(Expression<Func<UserAccess, bool>> expression,string connectionString, string providerName) {
           
            return All(connectionString,providerName).Any(expression);
        }        
        public static bool Exists(Expression<Func<UserAccess, bool>> expression) {
           
            return All().Any(expression);
        }        

        public static IList<UserAccess> Find(Expression<Func<UserAccess, bool>> expression) {
            
            var repo = GetRepo();
            return repo.Find(expression).ToList();
        }
        
        public static IList<UserAccess> Find(Expression<Func<UserAccess, bool>> expression,string connectionString, string providerName) {

            var repo = GetRepo(connectionString,providerName);
            return repo.Find(expression).ToList();

        }
        public static IQueryable<UserAccess> All(string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetAll();
        }
        public static IQueryable<UserAccess> All() {
            return GetRepo().GetAll();
        }
        
        public static PagedList<UserAccess> GetPaged(string sortBy, int pageIndex, int pageSize,string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetPaged(sortBy, pageIndex, pageSize);
        }
      
        public static PagedList<UserAccess> GetPaged(string sortBy, int pageIndex, int pageSize) {
            return GetRepo().GetPaged(sortBy, pageIndex, pageSize);
        }

        public static PagedList<UserAccess> GetPaged(int pageIndex, int pageSize,string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetPaged(pageIndex, pageSize);
            
        }


        public static PagedList<UserAccess> GetPaged(int pageIndex, int pageSize) {
            return GetRepo().GetPaged(pageIndex, pageSize);
            
        }

        public string KeyName()
        {
            return "Code";
        }

        public object KeyValue()
        {
            return this.Code;
        }
        
        public void SetKeyValue(object value) {
            if (value != null && value!=DBNull.Value) {
                var settable = value.ChangeTypeTo<short>();
                this.GetType().GetProperty(this.KeyName()).SetValue(this, settable, null);
            }
        }
        
        public override string ToString(){
            return this.Name.ToString();
        }

        public override bool Equals(object obj){
            if(obj.GetType()==typeof(UserAccess)){
                UserAccess compare=(UserAccess)obj;
                return compare.KeyValue()==this.KeyValue();
            }else{
                return base.Equals(obj);
            }
        }

        public string DescriptorValue()
        {
            return this.Name.ToString();
        }

        public string DescriptorColumn() {
            return "Name";
        }
        public static string GetKeyColumn()
        {
            return "Code";
        }        
        public static string GetDescriptorColumn()
        {
            return "Name";
        }
        
        #region ' Foreign Keys '
		[ScriptIgnore]
        public IQueryable<OAuthAccount> OAuthAccounts
        {
            get
            {
                
                  var repo=ODAF.Data.OAuthAccount.GetRepo();
                  return from items in repo.GetAll()
                       where items.UserAccess == _Code
                       select items;
            }
        }

        #endregion
        

        short _Code;
        public short Code
        {
            get { return _Code; }
            set
            {
                if(_Code!=value){
                    _Code=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Code");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _Name;
        public string Name
        {
            get { return _Name; }
            set
            {
                if(_Name!=value){
                    _Name=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Name");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }



        public DbCommand GetUpdateCommand() {
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToUpdateQuery(_db.Provider).GetCommand().ToDbCommand();
            
        }
        public DbCommand GetInsertCommand() {
 
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToInsertQuery(_db.Provider).GetCommand().ToDbCommand();
        }
        
        public DbCommand GetDeleteCommand() {
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToDeleteQuery(_db.Provider).GetCommand().ToDbCommand();
        }
       
        
        public void Update(){
            Update(_db.DataProvider);
        }
        
        public void Update(IDataProvider provider){
        
            
            if(this._dirtyColumns.Count>0)
                _repo.Update(this,provider);
            OnSaved();
       }
 
        public void Add(){
            Add(_db.DataProvider);
        }
        
        
       
        public void Add(IDataProvider provider){

            
            var key=KeyValue();
            if(key==null){
                var newKey=_repo.Add(this,provider);
                this.SetKeyValue(newKey);
            }else{
                _repo.Add(this,provider);
            }
            SetIsNew(false);
            OnSaved();
        }
        
                
        
        public void Save() {
            Save(_db.DataProvider);
        }      
        public void Save(IDataProvider provider) {
            
           
            if (_isNew) {
                Add(provider);
                
            } else {
                Update(provider);
            }
            
        }

        

        public void Delete(IDataProvider provider) {
                   
                 
            _repo.Delete(KeyValue());
            
                    }


        public void Delete() {
            Delete(_db.DataProvider);
        }


        public static void Delete(Expression<Func<UserAccess, bool>> expression) {
            var repo = GetRepo();
            
       
            
            repo.DeleteMany(expression);
            
        }

        

        public void Load(IDataReader rdr) {
            Load(rdr, true);
        }
        public void Load(IDataReader rdr, bool closeReader) {
            if (rdr.Read()) {

                try {
                    rdr.Load(this);
                    SetIsNew(false);
                    SetIsLoaded(true);
                } catch {
                    SetIsLoaded(false);
                    throw;
                }
            }else{
                SetIsLoaded(false);
            }

            if (closeReader)
                rdr.Dispose();
        }
        

    } 
    
    
    /// <summary>
    /// A class which represents the OAuthAccount table in the odaf Database.
    /// </summary>
    public partial class OAuthAccount: IActiveRecord
    {
    
        #region Built-in testing
        static TestRepository<OAuthAccount> _testRepo;
        

        
        static void SetTestRepo(){
            _testRepo = _testRepo ?? new TestRepository<OAuthAccount>(new ODAF.Data.odafDB());
        }
        public static void ResetTestRepo(){
            _testRepo = null;
            SetTestRepo();
        }
        public static void Setup(List<OAuthAccount> testlist){
            SetTestRepo();
            _testRepo._items = testlist;
        }
        public static void Setup(OAuthAccount item) {
            SetTestRepo();
            _testRepo._items.Add(item);
        }
        public static void Setup(int testItems) {
            SetTestRepo();
            for(int i=0;i<testItems;i++){
                OAuthAccount item=new OAuthAccount();
                _testRepo._items.Add(item);
            }
        }
        
        [ScriptIgnore]
        public bool TestMode = false;


        #endregion

        IRepository<OAuthAccount> _repo;
        ITable tbl;
        bool _isNew;
        public bool IsNew(){
            return _isNew;
        }
        
        public void SetIsLoaded(bool isLoaded){
            _isLoaded=isLoaded;
            if(isLoaded)
                OnLoaded();
        }
        
        public void SetIsNew(bool isNew){
            _isNew=isNew;
        }
        bool _isLoaded;
        public bool IsLoaded(){
            return _isLoaded;
        }
                
        List<IColumn> _dirtyColumns;
        public bool IsDirty(){
            return _dirtyColumns.Count>0;
        }
        
        public List<IColumn> GetDirtyColumns (){
            return _dirtyColumns;
        }

        ODAF.Data.odafDB _db;
        public OAuthAccount(string connectionString, string providerName) {

            _db=new ODAF.Data.odafDB(connectionString, providerName);
            Init();            
         }
        void Init(){
            TestMode=this._db.DataProvider.ConnectionString.Equals("test", StringComparison.InvariantCultureIgnoreCase);
            _dirtyColumns=new List<IColumn>();
            if(TestMode){
                OAuthAccount.SetTestRepo();
                _repo=_testRepo;
            }else{
                _repo = new SubSonicRepository<OAuthAccount>(_db);
            }
            tbl=_repo.GetTable();
            SetIsNew(true);
            OnCreated();       

        }
        
        public OAuthAccount(){
             _db=new ODAF.Data.odafDB();
            Init();            
        }
        
       
        partial void OnCreated();
            
        partial void OnLoaded();
        
        partial void OnSaved();
        
        partial void OnChanged();
        
        [ScriptIgnore]
        public IList<IColumn> Columns{
            get{
                return tbl.Columns;
            }
        }

        public OAuthAccount(Expression<Func<OAuthAccount, bool>> expression):this() {

            SetIsLoaded(_repo.Load(this,expression));
        }
        
       
        
        internal static IRepository<OAuthAccount> GetRepo(string connectionString, string providerName){
            ODAF.Data.odafDB db;
            if(String.IsNullOrEmpty(connectionString)){
                db=new ODAF.Data.odafDB();
            }else{
                db=new ODAF.Data.odafDB(connectionString, providerName);
            }
            IRepository<OAuthAccount> _repo;
            
            if(db.TestMode){
                OAuthAccount.SetTestRepo();
                _repo=_testRepo;
            }else{
                _repo = new SubSonicRepository<OAuthAccount>(db);
            }
            return _repo;        
        }       
        
        internal static IRepository<OAuthAccount> GetRepo(){
            return GetRepo("","");
        }
        
        public static OAuthAccount SingleOrDefault(Expression<Func<OAuthAccount, bool>> expression) {

            var repo = GetRepo();
            var results=repo.Find(expression);
            OAuthAccount single=null;
            if(results.Count() > 0){
                single=results.ToList()[0];
                single.OnLoaded();
                single.SetIsLoaded(true);
                single.SetIsNew(false);
            }

            return single;
        }      
        
        public static OAuthAccount SingleOrDefault(Expression<Func<OAuthAccount, bool>> expression,string connectionString, string providerName) {
            var repo = GetRepo(connectionString,providerName);
            var results=repo.Find(expression);
            OAuthAccount single=null;
            if(results.Count() > 0){
                single=results.ToList()[0];
            }

            return single;


        }
        
        
        public static bool Exists(Expression<Func<OAuthAccount, bool>> expression,string connectionString, string providerName) {
           
            return All(connectionString,providerName).Any(expression);
        }        
        public static bool Exists(Expression<Func<OAuthAccount, bool>> expression) {
           
            return All().Any(expression);
        }        

        public static IList<OAuthAccount> Find(Expression<Func<OAuthAccount, bool>> expression) {
            
            var repo = GetRepo();
            return repo.Find(expression).ToList();
        }
        
        public static IList<OAuthAccount> Find(Expression<Func<OAuthAccount, bool>> expression,string connectionString, string providerName) {

            var repo = GetRepo(connectionString,providerName);
            return repo.Find(expression).ToList();

        }
        public static IQueryable<OAuthAccount> All(string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetAll();
        }
        public static IQueryable<OAuthAccount> All() {
            return GetRepo().GetAll();
        }
        
        public static PagedList<OAuthAccount> GetPaged(string sortBy, int pageIndex, int pageSize,string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetPaged(sortBy, pageIndex, pageSize);
        }
      
        public static PagedList<OAuthAccount> GetPaged(string sortBy, int pageIndex, int pageSize) {
            return GetRepo().GetPaged(sortBy, pageIndex, pageSize);
        }

        public static PagedList<OAuthAccount> GetPaged(int pageIndex, int pageSize,string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetPaged(pageIndex, pageSize);
            
        }


        public static PagedList<OAuthAccount> GetPaged(int pageIndex, int pageSize) {
            return GetRepo().GetPaged(pageIndex, pageSize);
            
        }

        public string KeyName()
        {
            return "Id";
        }

        public object KeyValue()
        {
            return this.Id;
        }
        
        public void SetKeyValue(object value) {
            if (value != null && value!=DBNull.Value) {
                var settable = value.ChangeTypeTo<long>();
                this.GetType().GetProperty(this.KeyName()).SetValue(this, settable, null);
            }
        }
        
        public override string ToString(){
            return this.screen_name.ToString();
        }

        public override bool Equals(object obj){
            if(obj.GetType()==typeof(OAuthAccount)){
                OAuthAccount compare=(OAuthAccount)obj;
                return compare.KeyValue()==this.KeyValue();
            }else{
                return base.Equals(obj);
            }
        }

        public string DescriptorValue()
        {
            return this.screen_name.ToString();
        }

        public string DescriptorColumn() {
            return "screen_name";
        }
        public static string GetKeyColumn()
        {
            return "Id";
        }        
        public static string GetDescriptorColumn()
        {
            return "screen_name";
        }
        
        #region ' Foreign Keys '
		[ScriptIgnore]
        public IQueryable<OAuthClientApp> OAuthClientApps
        {
            get
            {
                
                  var repo=ODAF.Data.OAuthClientApp.GetRepo();
                  return from items in repo.GetAll()
                       where items.Id == _oauth_service_id
                       select items;
            }
        }

		[ScriptIgnore]
        public IQueryable<UserAccess> UserAccesses
        {
            get
            {
                
                  var repo=ODAF.Data.UserAccess.GetRepo();
                  return from items in repo.GetAll()
                       where items.Code == _UserAccess
                       select items;
            }
        }

		[ScriptIgnore]
        public IQueryable<UserRole> UserRoles
        {
            get
            {
                
                  var repo=ODAF.Data.UserRole.GetRepo();
                  return from items in repo.GetAll()
                       where items.Code == _UserRole
                       select items;
            }
        }

		[ScriptIgnore]
        public IQueryable<PointDataComment> PointDataComments
        {
            get
            {
                
                  var repo=ODAF.Data.PointDataComment.GetRepo();
                  return from items in repo.GetAll()
                       where items.CreatedById == _Id
                       select items;
            }
        }

		[ScriptIgnore]
        public IQueryable<PointDataSummary> PointDataSummaries
        {
            get
            {
                
                  var repo=ODAF.Data.PointDataSummary.GetRepo();
                  return from items in repo.GetAll()
                       where items.CreatedById == _Id
                       select items;
            }
        }

        #endregion
        

        long _Id;
        public long Id
        {
            get { return _Id; }
            set
            {
                if(_Id!=value){
                    _Id=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Id");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        long _user_id;
        public long user_id
        {
            get { return _user_id; }
            set
            {
                if(_user_id!=value){
                    _user_id=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="user_id");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _screen_name;
        public string screen_name
        {
            get { return _screen_name; }
            set
            {
                if(_screen_name!=value){
                    _screen_name=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="screen_name");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _oauth_token;
        public string oauth_token
        {
            get { return _oauth_token; }
            set
            {
                if(_oauth_token!=value){
                    _oauth_token=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="oauth_token");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _oauth_token_secret;
        public string oauth_token_secret
        {
            get { return _oauth_token_secret; }
            set
            {
                if(_oauth_token_secret!=value){
                    _oauth_token_secret=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="oauth_token_secret");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        short _UserRole;
        public short UserRole
        {
            get { return _UserRole; }
            set
            {
                if(_UserRole!=value){
                    _UserRole=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="UserRole");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        short _UserAccess;
        public short UserAccess
        {
            get { return _UserAccess; }
            set
            {
                if(_UserAccess!=value){
                    _UserAccess=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="UserAccess");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        DateTime _LastAccessedOn;
        public DateTime LastAccessedOn
        {
            get { return _LastAccessedOn; }
            set
            {
                if(_LastAccessedOn!=value){
                    _LastAccessedOn=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="LastAccessedOn");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        DateTime _TokenExpiry;
        public DateTime TokenExpiry
        {
            get { return _TokenExpiry; }
            set
            {
                if(_TokenExpiry!=value){
                    _TokenExpiry=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="TokenExpiry");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        int _oauth_service_id;
        public int oauth_service_id
        {
            get { return _oauth_service_id; }
            set
            {
                if(_oauth_service_id!=value){
                    _oauth_service_id=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="oauth_service_id");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _profile_image_url;
        public string profile_image_url
        {
            get { return _profile_image_url; }
            set
            {
                if(_profile_image_url!=value){
                    _profile_image_url=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="profile_image_url");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }



        public DbCommand GetUpdateCommand() {
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToUpdateQuery(_db.Provider).GetCommand().ToDbCommand();
            
        }
        public DbCommand GetInsertCommand() {
 
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToInsertQuery(_db.Provider).GetCommand().ToDbCommand();
        }
        
        public DbCommand GetDeleteCommand() {
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToDeleteQuery(_db.Provider).GetCommand().ToDbCommand();
        }
       
        
        public void Update(){
            Update(_db.DataProvider);
        }
        
        public void Update(IDataProvider provider){
        
            
            if(this._dirtyColumns.Count>0)
                _repo.Update(this,provider);
            OnSaved();
       }
 
        public void Add(){
            Add(_db.DataProvider);
        }
        
        
       
        public void Add(IDataProvider provider){

            
            var key=KeyValue();
            if(key==null){
                var newKey=_repo.Add(this,provider);
                this.SetKeyValue(newKey);
            }else{
                _repo.Add(this,provider);
            }
            SetIsNew(false);
            OnSaved();
        }
        
                
        
        public void Save() {
            Save(_db.DataProvider);
        }      
        public void Save(IDataProvider provider) {
            
           
            if (_isNew) {
                Add(provider);
                
            } else {
                Update(provider);
            }
            
        }

        

        public void Delete(IDataProvider provider) {
                   
                 
            _repo.Delete(KeyValue());
            
                    }


        public void Delete() {
            Delete(_db.DataProvider);
        }


        public static void Delete(Expression<Func<OAuthAccount, bool>> expression) {
            var repo = GetRepo();
            
       
            
            repo.DeleteMany(expression);
            
        }

        

        public void Load(IDataReader rdr) {
            Load(rdr, true);
        }
        public void Load(IDataReader rdr, bool closeReader) {
            if (rdr.Read()) {

                try {
                    rdr.Load(this);
                    SetIsNew(false);
                    SetIsLoaded(true);
                } catch {
                    SetIsLoaded(false);
                    throw;
                }
            }else{
                SetIsLoaded(false);
            }

            if (closeReader)
                rdr.Dispose();
        }
        

    } 
    
    
    /// <summary>
    /// A class which represents the OAuthClientApp table in the odaf Database.
    /// </summary>
    public partial class OAuthClientApp: IActiveRecord
    {
    
        #region Built-in testing
        static TestRepository<OAuthClientApp> _testRepo;
        

        
        static void SetTestRepo(){
            _testRepo = _testRepo ?? new TestRepository<OAuthClientApp>(new ODAF.Data.odafDB());
        }
        public static void ResetTestRepo(){
            _testRepo = null;
            SetTestRepo();
        }
        public static void Setup(List<OAuthClientApp> testlist){
            SetTestRepo();
            _testRepo._items = testlist;
        }
        public static void Setup(OAuthClientApp item) {
            SetTestRepo();
            _testRepo._items.Add(item);
        }
        public static void Setup(int testItems) {
            SetTestRepo();
            for(int i=0;i<testItems;i++){
                OAuthClientApp item=new OAuthClientApp();
                _testRepo._items.Add(item);
            }
        }
        
        [ScriptIgnore]
        public bool TestMode = false;


        #endregion

        IRepository<OAuthClientApp> _repo;
        ITable tbl;
        bool _isNew;
        public bool IsNew(){
            return _isNew;
        }
        
        public void SetIsLoaded(bool isLoaded){
            _isLoaded=isLoaded;
            if(isLoaded)
                OnLoaded();
        }
        
        public void SetIsNew(bool isNew){
            _isNew=isNew;
        }
        bool _isLoaded;
        public bool IsLoaded(){
            return _isLoaded;
        }
                
        List<IColumn> _dirtyColumns;
        public bool IsDirty(){
            return _dirtyColumns.Count>0;
        }
        
        public List<IColumn> GetDirtyColumns (){
            return _dirtyColumns;
        }

        ODAF.Data.odafDB _db;
        public OAuthClientApp(string connectionString, string providerName) {

            _db=new ODAF.Data.odafDB(connectionString, providerName);
            Init();            
         }
        void Init(){
            TestMode=this._db.DataProvider.ConnectionString.Equals("test", StringComparison.InvariantCultureIgnoreCase);
            _dirtyColumns=new List<IColumn>();
            if(TestMode){
                OAuthClientApp.SetTestRepo();
                _repo=_testRepo;
            }else{
                _repo = new SubSonicRepository<OAuthClientApp>(_db);
            }
            tbl=_repo.GetTable();
            SetIsNew(true);
            OnCreated();       

        }
        
        public OAuthClientApp(){
             _db=new ODAF.Data.odafDB();
            Init();            
        }
        
       
        partial void OnCreated();
            
        partial void OnLoaded();
        
        partial void OnSaved();
        
        partial void OnChanged();
        
        [ScriptIgnore]
        public IList<IColumn> Columns{
            get{
                return tbl.Columns;
            }
        }

        public OAuthClientApp(Expression<Func<OAuthClientApp, bool>> expression):this() {

            SetIsLoaded(_repo.Load(this,expression));
        }
        
       
        
        internal static IRepository<OAuthClientApp> GetRepo(string connectionString, string providerName){
            ODAF.Data.odafDB db;
            if(String.IsNullOrEmpty(connectionString)){
                db=new ODAF.Data.odafDB();
            }else{
                db=new ODAF.Data.odafDB(connectionString, providerName);
            }
            IRepository<OAuthClientApp> _repo;
            
            if(db.TestMode){
                OAuthClientApp.SetTestRepo();
                _repo=_testRepo;
            }else{
                _repo = new SubSonicRepository<OAuthClientApp>(db);
            }
            return _repo;        
        }       
        
        internal static IRepository<OAuthClientApp> GetRepo(){
            return GetRepo("","");
        }
        
        public static OAuthClientApp SingleOrDefault(Expression<Func<OAuthClientApp, bool>> expression) {

            var repo = GetRepo();
            var results=repo.Find(expression);
            OAuthClientApp single=null;
            if(results.Count() > 0){
                single=results.ToList()[0];
                single.OnLoaded();
                single.SetIsLoaded(true);
                single.SetIsNew(false);
            }

            return single;
        }      
        
        public static OAuthClientApp SingleOrDefault(Expression<Func<OAuthClientApp, bool>> expression,string connectionString, string providerName) {
            var repo = GetRepo(connectionString,providerName);
            var results=repo.Find(expression);
            OAuthClientApp single=null;
            if(results.Count() > 0){
                single=results.ToList()[0];
            }

            return single;


        }
        
        
        public static bool Exists(Expression<Func<OAuthClientApp, bool>> expression,string connectionString, string providerName) {
           
            return All(connectionString,providerName).Any(expression);
        }        
        public static bool Exists(Expression<Func<OAuthClientApp, bool>> expression) {
           
            return All().Any(expression);
        }        

        public static IList<OAuthClientApp> Find(Expression<Func<OAuthClientApp, bool>> expression) {
            
            var repo = GetRepo();
            return repo.Find(expression).ToList();
        }
        
        public static IList<OAuthClientApp> Find(Expression<Func<OAuthClientApp, bool>> expression,string connectionString, string providerName) {

            var repo = GetRepo(connectionString,providerName);
            return repo.Find(expression).ToList();

        }
        public static IQueryable<OAuthClientApp> All(string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetAll();
        }
        public static IQueryable<OAuthClientApp> All() {
            return GetRepo().GetAll();
        }
        
        public static PagedList<OAuthClientApp> GetPaged(string sortBy, int pageIndex, int pageSize,string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetPaged(sortBy, pageIndex, pageSize);
        }
      
        public static PagedList<OAuthClientApp> GetPaged(string sortBy, int pageIndex, int pageSize) {
            return GetRepo().GetPaged(sortBy, pageIndex, pageSize);
        }

        public static PagedList<OAuthClientApp> GetPaged(int pageIndex, int pageSize,string connectionString, string providerName) {
            return GetRepo(connectionString,providerName).GetPaged(pageIndex, pageSize);
            
        }


        public static PagedList<OAuthClientApp> GetPaged(int pageIndex, int pageSize) {
            return GetRepo().GetPaged(pageIndex, pageSize);
            
        }

        public string KeyName()
        {
            return "Id";
        }

        public object KeyValue()
        {
            return this.Id;
        }
        
        public void SetKeyValue(object value) {
            if (value != null && value!=DBNull.Value) {
                var settable = value.ChangeTypeTo<int>();
                this.GetType().GetProperty(this.KeyName()).SetValue(this, settable, null);
            }
        }
        
        public override string ToString(){
            return this.Guid.ToString();
        }

        public override bool Equals(object obj){
            if(obj.GetType()==typeof(OAuthClientApp)){
                OAuthClientApp compare=(OAuthClientApp)obj;
                return compare.KeyValue()==this.KeyValue();
            }else{
                return base.Equals(obj);
            }
        }

        
        public override int GetHashCode() {
            return this.Id;
        }
        
        public string DescriptorValue()
        {
            return this.Guid.ToString();
        }

        public string DescriptorColumn() {
            return "Guid";
        }
        public static string GetKeyColumn()
        {
            return "Id";
        }        
        public static string GetDescriptorColumn()
        {
            return "Guid";
        }
        
        #region ' Foreign Keys '
		[ScriptIgnore]
        public IQueryable<OAuthAccount> OAuthAccounts
        {
            get
            {
                
                  var repo=ODAF.Data.OAuthAccount.GetRepo();
                  return from items in repo.GetAll()
                       where items.oauth_service_id == _Id
                       select items;
            }
        }

        #endregion
        

        int _Id;
        public int Id
        {
            get { return _Id; }
            set
            {
                if(_Id!=value){
                    _Id=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Id");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _Guid;
        public string Guid
        {
            get { return _Guid; }
            set
            {
                if(_Guid!=value){
                    _Guid=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Guid");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _Name;
        public string Name
        {
            get { return _Name; }
            set
            {
                if(_Name!=value){
                    _Name=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Name");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _Comment;
        public string Comment
        {
            get { return _Comment; }
            set
            {
                if(_Comment!=value){
                    _Comment=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="Comment");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _ConsumerKey;
        public string ConsumerKey
        {
            get { return _ConsumerKey; }
            set
            {
                if(_ConsumerKey!=value){
                    _ConsumerKey=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="ConsumerKey");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _ConsumerSecret;
        public string ConsumerSecret
        {
            get { return _ConsumerSecret; }
            set
            {
                if(_ConsumerSecret!=value){
                    _ConsumerSecret=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="ConsumerSecret");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _CallbackUrl;
        public string CallbackUrl
        {
            get { return _CallbackUrl; }
            set
            {
                if(_CallbackUrl!=value){
                    _CallbackUrl=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="CallbackUrl");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _AppUrl;
        public string AppUrl
        {
            get { return _AppUrl; }
            set
            {
                if(_AppUrl!=value){
                    _AppUrl=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="AppUrl");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        DateTime? _CreatedOn;
        public DateTime? CreatedOn
        {
            get { return _CreatedOn; }
            set
            {
                if(_CreatedOn!=value){
                    _CreatedOn=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="CreatedOn");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }

        string _oauth_service_name;
        public string oauth_service_name
        {
            get { return _oauth_service_name; }
            set
            {
                if(_oauth_service_name!=value){
                    _oauth_service_name=value;
                    var col=tbl.Columns.SingleOrDefault(x=>x.Name=="oauth_service_name");
                    if(col!=null){
                        if(!_dirtyColumns.Any(x=>x.Name==col.Name) && _isLoaded){
                            _dirtyColumns.Add(col);
                        }
                    }
                    OnChanged();
                }
            }
        }



        public DbCommand GetUpdateCommand() {
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToUpdateQuery(_db.Provider).GetCommand().ToDbCommand();
            
        }
        public DbCommand GetInsertCommand() {
 
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToInsertQuery(_db.Provider).GetCommand().ToDbCommand();
        }
        
        public DbCommand GetDeleteCommand() {
            if(TestMode)
                return _db.DataProvider.CreateCommand();
            else
                return this.ToDeleteQuery(_db.Provider).GetCommand().ToDbCommand();
        }
       
        
        public void Update(){
            Update(_db.DataProvider);
        }
        
        public void Update(IDataProvider provider){
        
            
            if(this._dirtyColumns.Count>0)
                _repo.Update(this,provider);
            OnSaved();
       }
 
        public void Add(){
            Add(_db.DataProvider);
        }
        
        
       
        public void Add(IDataProvider provider){

            
            this.CreatedOn=DateTime.Now;
            
            var key=KeyValue();
            if(key==null){
                var newKey=_repo.Add(this,provider);
                this.SetKeyValue(newKey);
            }else{
                _repo.Add(this,provider);
            }
            SetIsNew(false);
            OnSaved();
        }
        
                
        
        public void Save() {
            Save(_db.DataProvider);
        }      
        public void Save(IDataProvider provider) {
            
           
            if (_isNew) {
                Add(provider);
                
            } else {
                Update(provider);
            }
            
        }

        

        public void Delete(IDataProvider provider) {
                   
                 
            _repo.Delete(KeyValue());
            
                    }


        public void Delete() {
            Delete(_db.DataProvider);
        }


        public static void Delete(Expression<Func<OAuthClientApp, bool>> expression) {
            var repo = GetRepo();
            
       
            
            repo.DeleteMany(expression);
            
        }

        

        public void Load(IDataReader rdr) {
            Load(rdr, true);
        }
        public void Load(IDataReader rdr, bool closeReader) {
            if (rdr.Read()) {

                try {
                    rdr.Load(this);
                    SetIsNew(false);
                    SetIsLoaded(true);
                } catch {
                    SetIsLoaded(false);
                    throw;
                }
            }else{
                SetIsLoaded(false);
            }

            if (closeReader)
                rdr.Dispose();
        }
        

    } 
}
