


using System;
using SubSonic.Schema;
using System.Collections.Generic;
using SubSonic.DataProviders;
using System.Data;

namespace ODAF.Data {
	
        /// <summary>
        /// Table: PointDataLayer
        /// Primary Key: Id
        /// </summary>

        public class PointDataLayerTable: DatabaseTable {
            
            public PointDataLayerTable(IDataProvider provider):base("PointDataLayer",provider){
                ClassName = "PointDataLayer";
                //SchemaName = "dbo";
                //SchemaName is deprecated in SQL Server 2008 (thus Azure), so we blank it out
                SchemaName = "";
                

                Columns.Add(new DatabaseColumn("Id", this)
                {
	                IsPrimaryKey = true,
	                DataType = DbType.Int64,
	                IsNullable = false,
	                AutoIncrement = true,
	                IsForeignKey = false,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("Guid", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 255
                });

                Columns.Add(new DatabaseColumn("Name", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 50
                });

                Columns.Add(new DatabaseColumn("IsSystem", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.Boolean,
	                IsNullable = true,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("CreatedOn", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.DateTime,
	                IsNullable = true,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 0
                });
                    
                
                
            }
            
            public IColumn Id{
                get{
                    return this.GetColumn("Id");
                }
            }
				
   			public static string IdColumn{
			      get{
        			return "Id";
      			}
		    }
            
            public IColumn Guid{
                get{
                    return this.GetColumn("Guid");
                }
            }
				
   			public static string GuidColumn{
			      get{
        			return "Guid";
      			}
		    }
            
            public IColumn Name{
                get{
                    return this.GetColumn("Name");
                }
            }
				
   			public static string NameColumn{
			      get{
        			return "Name";
      			}
		    }
            
            public IColumn IsSystem{
                get{
                    return this.GetColumn("IsSystem");
                }
            }
				
   			public static string IsSystemColumn{
			      get{
        			return "IsSystem";
      			}
		    }
            
            public IColumn CreatedOn{
                get{
                    return this.GetColumn("CreatedOn");
                }
            }
				
   			public static string CreatedOnColumn{
			      get{
        			return "CreatedOn";
      			}
		    }
            
                    
        }
        
        /// <summary>
        /// Table: PointDataSummary
        /// Primary Key: Id
        /// </summary>

        public class PointDataSummaryTable: DatabaseTable {
            
            public PointDataSummaryTable(IDataProvider provider):base("PointDataSummary",provider){
                ClassName = "PointDataSummary";
                //SchemaName = "dbo";
                //SchemaName is deprecated in SQL Server 2008 (thus Azure), so we blank it out
                SchemaName = "";
                

                Columns.Add(new DatabaseColumn("Id", this)
                {
	                IsPrimaryKey = true,
	                DataType = DbType.Int64,
	                IsNullable = false,
	                AutoIncrement = true,
	                IsForeignKey = true,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("Description", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 4000
                });

                Columns.Add(new DatabaseColumn("Latitude", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.Decimal,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("Longitude", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.Decimal,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("LayerId", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 40
                });

                Columns.Add(new DatabaseColumn("Tag", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = true,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = -1
                });

                Columns.Add(new DatabaseColumn("RatingCount", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.Int32,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("RatingTotal", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.Int64,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("CommentCount", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.Int32,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("CreatedOn", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.DateTime,
	                IsNullable = true,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("ModifiedOn", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.DateTime,
	                IsNullable = true,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("Guid", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = true,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 100
                });

                Columns.Add(new DatabaseColumn("Name", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 255
                });

                Columns.Add(new DatabaseColumn("CreatedById", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.Int64,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = true,
	                MaxLength = 0
                });
                    
                
                
            }
            
            public IColumn Id{
                get{
                    return this.GetColumn("Id");
                }
            }
				
   			public static string IdColumn{
			      get{
        			return "Id";
      			}
		    }
            
            public IColumn Description{
                get{
                    return this.GetColumn("Description");
                }
            }
				
   			public static string DescriptionColumn{
			      get{
        			return "Description";
      			}
		    }
            
            public IColumn Latitude{
                get{
                    return this.GetColumn("Latitude");
                }
            }
				
   			public static string LatitudeColumn{
			      get{
        			return "Latitude";
      			}
		    }
            
            public IColumn Longitude{
                get{
                    return this.GetColumn("Longitude");
                }
            }
				
   			public static string LongitudeColumn{
			      get{
        			return "Longitude";
      			}
		    }
            
            public IColumn LayerId{
                get{
                    return this.GetColumn("LayerId");
                }
            }
				
   			public static string LayerIdColumn{
			      get{
        			return "LayerId";
      			}
		    }
            
            public IColumn Tag{
                get{
                    return this.GetColumn("Tag");
                }
            }
				
   			public static string TagColumn{
			      get{
        			return "Tag";
      			}
		    }
            
            public IColumn RatingCount{
                get{
                    return this.GetColumn("RatingCount");
                }
            }
				
   			public static string RatingCountColumn{
			      get{
        			return "RatingCount";
      			}
		    }
            
            public IColumn RatingTotal{
                get{
                    return this.GetColumn("RatingTotal");
                }
            }
				
   			public static string RatingTotalColumn{
			      get{
        			return "RatingTotal";
      			}
		    }
            
            public IColumn CommentCount{
                get{
                    return this.GetColumn("CommentCount");
                }
            }
				
   			public static string CommentCountColumn{
			      get{
        			return "CommentCount";
      			}
		    }
            
            public IColumn CreatedOn{
                get{
                    return this.GetColumn("CreatedOn");
                }
            }
				
   			public static string CreatedOnColumn{
			      get{
        			return "CreatedOn";
      			}
		    }
            
            public IColumn ModifiedOn{
                get{
                    return this.GetColumn("ModifiedOn");
                }
            }
				
   			public static string ModifiedOnColumn{
			      get{
        			return "ModifiedOn";
      			}
		    }
            
            public IColumn Guid{
                get{
                    return this.GetColumn("Guid");
                }
            }
				
   			public static string GuidColumn{
			      get{
        			return "Guid";
      			}
		    }
            
            public IColumn Name{
                get{
                    return this.GetColumn("Name");
                }
            }
				
   			public static string NameColumn{
			      get{
        			return "Name";
      			}
		    }
            
            public IColumn CreatedById{
                get{
                    return this.GetColumn("CreatedById");
                }
            }
				
   			public static string CreatedByIdColumn{
			      get{
        			return "CreatedById";
      			}
		    }
            
                    
        }
        
        /// <summary>
        /// Table: PointDataComment
        /// Primary Key: Id
        /// </summary>

        public class PointDataCommentTable: DatabaseTable {
            
            public PointDataCommentTable(IDataProvider provider):base("PointDataComment",provider){
                ClassName = "PointDataComment";
                //SchemaName = "dbo";
                //SchemaName is deprecated in SQL Server 2008 (thus Azure), so we blank it out
                SchemaName = "";
                

                Columns.Add(new DatabaseColumn("Id", this)
                {
	                IsPrimaryKey = true,
	                DataType = DbType.Int64,
	                IsNullable = false,
	                AutoIncrement = true,
	                IsForeignKey = false,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("Text", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 4000
                });

                Columns.Add(new DatabaseColumn("CreatedOn", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.DateTime,
	                IsNullable = true,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("CreatedById", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.Int64,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = true,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("SummaryId", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.Int64,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = true,
	                MaxLength = 0
                });
                    
                
                
            }
            
            public IColumn Id{
                get{
                    return this.GetColumn("Id");
                }
            }
				
   			public static string IdColumn{
			      get{
        			return "Id";
      			}
		    }
            
            public IColumn Text{
                get{
                    return this.GetColumn("Text");
                }
            }
				
   			public static string TextColumn{
			      get{
        			return "Text";
      			}
		    }
            
            public IColumn CreatedOn{
                get{
                    return this.GetColumn("CreatedOn");
                }
            }
				
   			public static string CreatedOnColumn{
			      get{
        			return "CreatedOn";
      			}
		    }
            
            public IColumn CreatedById{
                get{
                    return this.GetColumn("CreatedById");
                }
            }
				
   			public static string CreatedByIdColumn{
			      get{
        			return "CreatedById";
      			}
		    }
            
            public IColumn SummaryId{
                get{
                    return this.GetColumn("SummaryId");
                }
            }
				
   			public static string SummaryIdColumn{
			      get{
        			return "SummaryId";
      			}
		    }
            
                    
        }
        
        /// <summary>
        /// Table: UserRole
        /// Primary Key: Code
        /// </summary>

        public class UserRoleTable: DatabaseTable {
            
            public UserRoleTable(IDataProvider provider):base("UserRole",provider){
                ClassName = "UserRole";
                //SchemaName = "dbo";
                //SchemaName is deprecated in SQL Server 2008 (thus Azure), so we blank it out
                SchemaName = "";
                

                Columns.Add(new DatabaseColumn("Code", this)
                {
	                IsPrimaryKey = true,
	                DataType = DbType.Int16,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = true,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("Name", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 20
                });
                    
                
                
            }
            
            public IColumn Code{
                get{
                    return this.GetColumn("Code");
                }
            }
				
   			public static string CodeColumn{
			      get{
        			return "Code";
      			}
		    }
            
            public IColumn Name{
                get{
                    return this.GetColumn("Name");
                }
            }
				
   			public static string NameColumn{
			      get{
        			return "Name";
      			}
		    }
            
                    
        }
        
        /// <summary>
        /// Table: UserAccess
        /// Primary Key: Code
        /// </summary>

        public class UserAccessTable: DatabaseTable {
            
            public UserAccessTable(IDataProvider provider):base("UserAccess",provider){
                ClassName = "UserAccess";
                //SchemaName = "dbo";
                //SchemaName is deprecated in SQL Server 2008 (thus Azure), so we blank it out
                SchemaName = "";
                

                Columns.Add(new DatabaseColumn("Code", this)
                {
	                IsPrimaryKey = true,
	                DataType = DbType.Int16,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = true,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("Name", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 20
                });
                    
                
                
            }
            
            public IColumn Code{
                get{
                    return this.GetColumn("Code");
                }
            }
				
   			public static string CodeColumn{
			      get{
        			return "Code";
      			}
		    }
            
            public IColumn Name{
                get{
                    return this.GetColumn("Name");
                }
            }
				
   			public static string NameColumn{
			      get{
        			return "Name";
      			}
		    }
            
                    
        }
        
        /// <summary>
        /// Table: OAuthAccount
        /// Primary Key: Id
        /// </summary>

        public class OAuthAccountTable: DatabaseTable {
            
            public OAuthAccountTable(IDataProvider provider):base("OAuthAccount",provider){
                ClassName = "OAuthAccount";
                //SchemaName = "dbo";
                //SchemaName is deprecated in SQL Server 2008 (thus Azure), so we blank it out
                SchemaName = "";
                

                Columns.Add(new DatabaseColumn("Id", this)
                {
	                IsPrimaryKey = true,
	                DataType = DbType.Int64,
	                IsNullable = false,
	                AutoIncrement = true,
	                IsForeignKey = true,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("user_id", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.Int64,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("screen_name", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 30
                });

                Columns.Add(new DatabaseColumn("oauth_token", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 255
                });

                Columns.Add(new DatabaseColumn("oauth_token_secret", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 255
                });

                Columns.Add(new DatabaseColumn("UserRole", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.Int16,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = true,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("UserAccess", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.Int16,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = true,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("LastAccessedOn", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.DateTime,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("TokenExpiry", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.DateTime,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("oauth_service_id", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.Int32,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = true,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("profile_image_url", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 255
                });
                    
                
                
            }
            
            public IColumn Id{
                get{
                    return this.GetColumn("Id");
                }
            }
				
   			public static string IdColumn{
			      get{
        			return "Id";
      			}
		    }
            
            public IColumn user_id{
                get{
                    return this.GetColumn("user_id");
                }
            }
				
   			public static string user_idColumn{
			      get{
        			return "user_id";
      			}
		    }
            
            public IColumn screen_name{
                get{
                    return this.GetColumn("screen_name");
                }
            }
				
   			public static string screen_nameColumn{
			      get{
        			return "screen_name";
      			}
		    }
            
            public IColumn oauth_token{
                get{
                    return this.GetColumn("oauth_token");
                }
            }
				
   			public static string oauth_tokenColumn{
			      get{
        			return "oauth_token";
      			}
		    }
            
            public IColumn oauth_token_secret{
                get{
                    return this.GetColumn("oauth_token_secret");
                }
            }
				
   			public static string oauth_token_secretColumn{
			      get{
        			return "oauth_token_secret";
      			}
		    }
            
            public IColumn UserRole{
                get{
                    return this.GetColumn("UserRole");
                }
            }
				
   			public static string UserRoleColumn{
			      get{
        			return "UserRole";
      			}
		    }
            
            public IColumn UserAccess{
                get{
                    return this.GetColumn("UserAccess");
                }
            }
				
   			public static string UserAccessColumn{
			      get{
        			return "UserAccess";
      			}
		    }
            
            public IColumn LastAccessedOn{
                get{
                    return this.GetColumn("LastAccessedOn");
                }
            }
				
   			public static string LastAccessedOnColumn{
			      get{
        			return "LastAccessedOn";
      			}
		    }
            
            public IColumn TokenExpiry{
                get{
                    return this.GetColumn("TokenExpiry");
                }
            }
				
   			public static string TokenExpiryColumn{
			      get{
        			return "TokenExpiry";
      			}
		    }
            
            public IColumn oauth_service_id{
                get{
                    return this.GetColumn("oauth_service_id");
                }
            }
				
   			public static string oauth_service_idColumn{
			      get{
        			return "oauth_service_id";
      			}
		    }
            
            public IColumn profile_image_url{
                get{
                    return this.GetColumn("profile_image_url");
                }
            }
				
   			public static string profile_image_urlColumn{
			      get{
        			return "profile_image_url";
      			}
		    }
            
                    
        }
        
        /// <summary>
        /// Table: OAuthClientApp
        /// Primary Key: Id
        /// </summary>

        public class OAuthClientAppTable: DatabaseTable {
            
            public OAuthClientAppTable(IDataProvider provider):base("OAuthClientApp",provider){
                ClassName = "OAuthClientApp";
                //SchemaName = "dbo";
                //SchemaName is deprecated in SQL Server 2008 (thus Azure), so we blank it out
                SchemaName = "";
                

                Columns.Add(new DatabaseColumn("Id", this)
                {
	                IsPrimaryKey = true,
	                DataType = DbType.Int32,
	                IsNullable = false,
	                AutoIncrement = true,
	                IsForeignKey = true,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("Guid", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 255
                });

                Columns.Add(new DatabaseColumn("Name", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 50
                });

                Columns.Add(new DatabaseColumn("Comment", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 255
                });

                Columns.Add(new DatabaseColumn("ConsumerKey", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 255
                });

                Columns.Add(new DatabaseColumn("ConsumerSecret", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 255
                });

                Columns.Add(new DatabaseColumn("CallbackUrl", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 1000
                });

                Columns.Add(new DatabaseColumn("AppUrl", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 1000
                });

                Columns.Add(new DatabaseColumn("CreatedOn", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.DateTime,
	                IsNullable = true,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 0
                });

                Columns.Add(new DatabaseColumn("oauth_service_name", this)
                {
	                IsPrimaryKey = false,
	                DataType = DbType.String,
	                IsNullable = false,
	                AutoIncrement = false,
	                IsForeignKey = false,
	                MaxLength = 50
                });
                    
                
                
            }
            
            public IColumn Id{
                get{
                    return this.GetColumn("Id");
                }
            }
				
   			public static string IdColumn{
			      get{
        			return "Id";
      			}
		    }
            
            public IColumn Guid{
                get{
                    return this.GetColumn("Guid");
                }
            }
				
   			public static string GuidColumn{
			      get{
        			return "Guid";
      			}
		    }
            
            public IColumn Name{
                get{
                    return this.GetColumn("Name");
                }
            }
				
   			public static string NameColumn{
			      get{
        			return "Name";
      			}
		    }
            
            public IColumn Comment{
                get{
                    return this.GetColumn("Comment");
                }
            }
				
   			public static string CommentColumn{
			      get{
        			return "Comment";
      			}
		    }
            
            public IColumn ConsumerKey{
                get{
                    return this.GetColumn("ConsumerKey");
                }
            }
				
   			public static string ConsumerKeyColumn{
			      get{
        			return "ConsumerKey";
      			}
		    }
            
            public IColumn ConsumerSecret{
                get{
                    return this.GetColumn("ConsumerSecret");
                }
            }
				
   			public static string ConsumerSecretColumn{
			      get{
        			return "ConsumerSecret";
      			}
		    }
            
            public IColumn CallbackUrl{
                get{
                    return this.GetColumn("CallbackUrl");
                }
            }
				
   			public static string CallbackUrlColumn{
			      get{
        			return "CallbackUrl";
      			}
		    }
            
            public IColumn AppUrl{
                get{
                    return this.GetColumn("AppUrl");
                }
            }
				
   			public static string AppUrlColumn{
			      get{
        			return "AppUrl";
      			}
		    }
            
            public IColumn CreatedOn{
                get{
                    return this.GetColumn("CreatedOn");
                }
            }
				
   			public static string CreatedOnColumn{
			      get{
        			return "CreatedOn";
      			}
		    }
            
            public IColumn oauth_service_name{
                get{
                    return this.GetColumn("oauth_service_name");
                }
            }
				
   			public static string oauth_service_nameColumn{
			      get{
        			return "oauth_service_name";
      			}
		    }
            
                    
        }
        
}